// Saves options to chrome.storage
function save_options() {
  var native_language = document.getElementById('native_language').value;
  var foreign_language = document.getElementById('foreign_language').value;
  var num_def_before_quiz = document.getElementById('num_def_before_quiz').value;
  var disabled = document.getElementById('disabled').checked ? 'true' : 'false';

  chrome.storage.sync.set({
    native_language: native_language,
    foreign_language: foreign_language,
    num_def_before_quiz: num_def_before_quiz,
    disabled: disabled
  }, function() {
    // Update status to let user know options were saved.
    var status = document.getElementById('status');
    status.textContent = 'Options saved.';
    setTimeout(function() {
      status.textContent = '';
    }, 750);
  });
}

// Restores select box and checkbox state using the preferences
// stored in chrome.storage.
function restore_options() {
  // Use default value color = 'red' and likesColor = true.
  chrome.storage.sync.get({
    native_language: "eng",
    foreign_language: "deu",
    num_def_before_quiz: "5",
    disabled: "false"
  }, function(items) {
    document.getElementById('native_language').value = items.native_language;
    document.getElementById('foreign_language').value = items.foreign_language;
    document.getElementById('num_def_before_quiz').value = items.num_def_before_quiz;
    document.getElementById('disabled').checked = items.disabled == 'true';
  });
}

document.addEventListener('DOMContentLoaded', restore_options);
document.getElementById('save').addEventListener('click', save_options);
chrome.storage.onChanged.addListener(function(changes, namespace) { restore_options(); });
